<template>
  <div :class="{'full-iframe': isFullIframe}">
    <div v-if="isGameDisable" class="h-screen game-disable-container">
      <div class="flex flex-col justify-center items-center text-center w-[320px] m-auto sm:m-unset h-screen sm:w-full gap-2 sm:gap-6">
        <div class="flex flex-col justify-center relative">
          <img :src="getAssetImage('assets/common/img_game_close_bg.png')" class="bg-cover w-[250px] h-[165px] sm:w-[600px] sm:h-[400px]" />
          <blendGameClose class="w-[208px] h-[105px] sm:w-[416px] sm:h-[210px] bg-cover absolute left-[50%] translate-x-[-50%] bottom-0" /> 
          <img :src="getAssetImage('assets/common/img_game_close_image.png')" class="w-[208px] h-[105px] sm:w-[416px] sm:h-[210px] mix-blend-hard-light bg-cover absolute left-[50%] translate-x-[-50%] bottom-0" />
        </div>
        <div class="text-2xl sm:text-[32px] uppercase  font-medium tc-2" >{{$t('game_is_disabled')}}</div>
        <div class="text-base sm:text-2xl  font-medium tc-2">{{$t('please_try_again_later')}}</div>
      </div>
    </div>
    <div
      v-if="(isPopup || isSilentRedirect) && !isGameDisable"
      v-loading="true"
      style="width: 100%; height: 100vh"
    ></div>
    <div
      v-else-if="isFullMobile && !isGameDisable"
      class="flex fixed justify-center items-center z-[1000] top-0 left-0 bg-black"
      style="width: 100%; height: 100vh;"
    >
      <div @click="showHeader = true" class="fixed top-0 h-5 w-[60px] flex justify-center items-center btn-toggle-header">
        <font-awesome-icon
          icon="angle-down"
          class="text-base fc-primary"
        />
      </div>
      <el-dialog
        v-model="showHeader"
        destroy-on-close
        width="100%"
        custom-class="header-dialog z-[1001]"
        :close-on-click-modal="false"
        :show-close="false"
      >
        <div class="flex w-full justify-between items-center">
          <div>
            <font-awesome-icon @click="goBack()" class="text-[#606060] text-base" icon="chevron-left" />
          </div>
        <div @click="showHeader = false" class="fc-primary">{{$t('Full Screen')}}</div>
        </div>
      </el-dialog>
      <span class="loader" v-if="isGameProviderLoading"></span>
      <iframe
        v-else
        id="game-iframe"
        :src="`${gameProviderUrl}`"
        frameborder="0"
        scrolling="yes"
      ></iframe>
    </div>
    <div v-else-if="!isGameDisable">
      <GameDetailBMD1 v-if="isTheme('modern')" :game-provider-url="gameProviderUrl" />
      <div v-else v-loading="isGameProviderLoading">
        <iframe
          :src="`${gameProviderUrl}`"
          frameborder="0"
          class="embed-responsive-item w-full h-full"
          :style="`height: ${height}; width: 100%`"
          scrolling="yes"
        ></iframe>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import apis from "@/utils/apis";
import apiCalling from "~/utils/apiCalling";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import { store } from "~~/store";
import GameDetailBMD1 from "@/components/theme/desktop/modern/game-detail.client.vue";
import { ILoginTelegram } from "~~/models/telegramLogin";
import EnumApiErrorCode from "~~/models/enums/enumApiErrorCode";
const { getAssetImage } = commonHelper
import blendGameClose from "~/assets/icons/blend-game-close.svg?component";

const isTheme = (theme: string) => (useIsDesktop() && store.state.selectedThemeName === theme);
const route = useRoute();
const router = useRouter();
const gameProviderUrl = ref("");
const isGameProviderLoading = ref(true);
const isMobile = !useIsDesktop();
const isWebId2625 = store.state.webId === 2625;
const config = useRuntimeConfig();
const isDemo = config.public.CURRENTLY_ENV === "demo";
const isPeruTheme = store.state.selectedThemeName === 'peru';
const height = ref(isMobile ? (isPeruTheme ? '100vh' : 'calc(100vh - 155px)') : '90vh');
const showHeader = ref(false);
const isGameDisable = ref(false);

const goBack = ()=>{
  router.go(-1);
}

if (isDemo && isWebId2625) {
  height.value = '89vh';
}

const isPopup = computed(() => Object.keys(route.query).includes("pop"));
const isSilentRedirect = computed(() =>
  Object.keys(route.query).includes("silent")
);
const isIframe = computed(() => Object.keys(route.query).includes("iframe"));
const isFullMobile = computed(() => isIframe.value && isMobile)

const gameProviderLogin = async () => {
  const routeNameTelegram = route.query.telegram;
  const telegramLoginReqeust: ILoginTelegram = {
    Token: routeNameTelegram?.toString() ?? '',
  };
  isGameProviderLoading.value = true;
  const id = Number(route.params.id);
  const entrance = String(route.query.entrance ?? EnumEntranceLocation.Other);
  const tab = String(route.query.tab).toLowerCase();
  const isMapping = ["sport", "sports"].includes(tab) && store.state.locale === "pt_BR";
  if (routeNameTelegram) {
    const response = await apis.loginTelgram(telegramLoginReqeust);
      if (response.isSuccessful) {
        window.location.href = response.Data.Url;
      }
  } else {
    if (route.query.desktop !== undefined) {
      const response = await apis.getGameProviderLogin(id, entrance, tab);
      if (response.isSuccessful) {
        gameProviderUrl.value = response.Data.Url;
      }
    } else {
      const response = await apiCalling.callGameProviderLogin(id, entrance, route.query.DesktopView !== undefined, isMapping ? "pt_PT" : "");
      if (response.ErrorCode === 0) {
        gameProviderUrl.value = response.Data.Url;
      }
      else if (response.ErrorCode === EnumApiErrorCode.GameIsDisabled) {
        isGameDisable.value = true;
      }
    }
  }
  isGameProviderLoading.value = false;
  if ((isPopup.value || isSilentRedirect.value) && isGameDisable.value) {
  if (!window.sessionStorage.getItem('reloaded')) {
    window.sessionStorage.setItem('reloaded', 'true');
    window.location.href = gameProviderUrl.value;
  }
  }
  else if (isPopup.value || isSilentRedirect.value){
    window.location.href = gameProviderUrl.value;
  }
};
gameProviderLogin();
const isFullIframe = computed(() => route.query.tab === "sports");
</script>

<style scoped>
:deep(.header-dialog.el-dialog) {
    --el-dialog-margin-top: 0;
    --el-dialog-bg-color: var(--background2);
    margin-right: 0px;
    margin-bottom: 0px;
    min-height: 5px;
    padding: 16px;
    display: flex;
    justify-content: center;
}
iframe#game-iframe {
  height: 100vh;
  width: 100%;
  position: fixed;
  top: 0;
  left: 0;
}
@supports (height:100dvh) {
  iframe#game-iframe {
    height: 100dvh;
  }
}
:deep(.header-dialog .el-dialog__body) {
  padding: 0;
  display: flex;
  width: 100%;
}
:deep(.el-dialog__header) {
  display: none;
}
.btn-toggle-header {
  background-color: rgb(255 255 255 / 20%);
  border-radius: 0px 0px 4px 4px;
  margin: 0 auto;
  left: calc(50% - 25px);
  z-index: 1
}
:deep(.el-dialog.header-dialog:focus-visible) {
    outline: 0;
}
:deep(.el-overlay) {
  background-color: transparent;
}
.loader {
  width: 48px;
  height: 48px;
  border: 3px solid #FFF;
  border-bottom-color: transparent;
  border-radius: 50%;
  display: inline-block;
  box-sizing: border-box;
  animation: rotation 1s linear infinite;
}
@keyframes rotation {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
</style>
<style lang="scss">
.sport-full-w:has(.full-iframe) {
  max-width: 100% !important;
  padding-left: 48px;
  .announcement-container {
    flex-grow: 1;
  }
}
</style>
